#include <stdlib.h>
#include <iostream.h>
#include <Instrument.h>
#include <ugens.h>
#include <Ougens.h>
#include "PINES.h"
#include <rt.h>

PINES::PINES() : Instrument()
{
}

int PINES::init(float p[], int n_args)
{
	// p0 = start, p[1] = duration, p[2] = amp
	// p3 = duration of each 'vortex'
	// p4,p5 = lower and upper limit of time between each 'vortex' burst

	nsamps = rtsetoutput(p[0], p[1], this);

	amp = p[2];

	theVortex = new Ooscili(1.0/p[3], 1);	// gen 1 contains the 'vortex'
						// burst waveform
	burstsamps = p[3] * SR; // # of samples for 1 cycle of the waveform

	// we will also randomly choose a wait period between 'bursts'
	// these are the upper and lower bounds (in samples)
	waitsampslo = p[4] * SR;
	waitsampshi = p[5] * SR;

	countup = 0;
	resetpoint = 0;

	theRand = new Orand();
	theRand->timeseed();

	return(nsamps);
}

int PINES::run()
{
	int i;
	float out[2];
	
	Instrument::run();


	for (i = 0; i < chunksamps; i++) {
		if (countup < resetpoint) {
			if (countup < burstsamps) {
				out[0] = theVortex->next() * amp;
			} else {
				out[0] = 0.0;
			}
		} else {
			theVortex->setphase(0.0);
			resetpoint = (int)(theRand->range((float)waitsampslo, (float)waitsampshi));
			resetpoint += burstsamps;
			countup = 0;
			out[0] = 0.0;
		}

		out[1] = out[0];
		rtaddout(out);

		countup++;
		cursamp++;
	}
	return i;
}

Instrument*
makePINES()
{
	PINES *inst;
	inst = new PINES();
	inst->set_bus_config("PINES");
	return inst;
}

void
rtprofile()
{
	RT_INTRO("PINES",makePINES);
}

